using ETHZ.C0284H.Calculator.CalculatorNode.Visitor;

namespace ETHZ.C0284H.Calculator.CalculatorNode
{

	/// <summary>
	/// Operator "+"
	/// </summary>
	public sealed class PlusOperator : AbstractOperator
	{
		/// <summary>
		/// Plus operator constructor
		/// </summary>
		public PlusOperator():base("+")
		{}

		/// <summary>
		/// Implement double dispatch using this operator and the specific visitor passed as argument
		/// </summary>
		/// <param name="visitor">
		/// A <see cref="IVisitor"/>
		/// </param>
		public override void Accept(IVisitor visitor)
		{
		    if (visitor != null)
		    {
		        visitor.VisitPlusOperator(this);
		    }
		}
	}
}
	
