using System;
using System.Collections.Generic;
using ETHZ.C0284H.Calculator.Instruct.Visitor;
using ETHZ.C0284H.Calculator.UI;

namespace ETHZ.C0284H.Calculator.Instruct.Commands
{
    /// <summary>
    /// Command instructs.
    /// </summary>
    public abstract class CommandInstruct : ICalculatorInstruct
    {
        // Type of the command.
        private readonly CalculatorCommandType _commandType;

        protected CommandInstruct(CalculatorCommandType command)
        {
            _commandType = command;
            InstructCode = command.ToString();
        }

        /// <summary>
        /// Type property of a command.
        /// </summary>
        public CalculatorCommandType CommandType
        {
            get { return _commandType;  }
        }

        public string InstructText
        {
            get
            {
                return UIResourceManager.Instance.GetLocalizedCommand(CommandType);
            }
        }
        public string InstructCode { get; private set; }

        /// <summary>
        /// Accept method.
        /// </summary>
        /// <param name="visitor"></param>
        public abstract void Accept(ICalculatorInstructVisitor visitor);

    }
}
