using System;
using System.Collections.Generic;
using ETHZ.C0284H.Calculator.Instruct.Visitor;
using ETHZ.C0284H.Calculator.Utils;

namespace ETHZ.C0284H.Calculator.Instruct.Operators
{
    /// <summary>
    /// Operator instruct.
    /// </summary>
    public abstract class OperatorInstruct: ICalculatorInstruct
    { 
        // Protected constructor.
        protected OperatorInstruct(CalculatorOperatorType operatorType)
        {
            InstructCode = Enums.GetEnumDescription(operatorType);
        }

        /// <summary>
        /// InstructText of an operator.
        /// </summary>
        public string InstructText
        {
            get
            {
                return InstructCode;
            }
        }

        public string InstructCode { get; private set; }

        /// <summary>
        /// Accept method.
        /// </summary>
        /// <param name="visitor"></param>
        public abstract void Accept(ICalculatorInstructVisitor visitor);
    }
}
